/*************************************************************************************
 **  Q-KernelFree  Copyright (C) 2013 QuasarSoft Ltd.                               **
 **                                                                                 **
 **  This file is part of Q-KernelFree distribution.                                **
 **  Q-KernelFree is free software:  you can redistribute it and/or modify it under **
 **  the terms of the  GNU  General  Public  License  (version 3) as published  by  **
 **  the Free Software  Foundation ***** AND MODIFIED BY ***** the QuasarSoft Ltd.  **
 **  exception.                                                                     **
 **                                                                                 **
 **    *********************** The QuasarSoft Ltd. EXCEPTION ******************     **
 **    * You may not exercise any of the rights granted to You in any manner  *     **
 **    * that is primarily intended for or directed toward commercial         *     **
 **    * advantage or private monetary compensation. The exchange of the      *     **
 **    * Program for other copyrighted works by means of digital file-sharing *     **
 **    * or otherwise shall not be considered to be intended for or directed  *     **
 **    * toward commercial advantage or private monetary compensation,        *     **
 **    * provided there is no payment of any monetary compensation in         *     **
 **    * connection with the exchange of copyrighted works.                   *     **
 **    ************************************************************************     **
 **                                                                                 **
 **  Q-KernelFree is distributed in the hope that it will be useful,  but  WITHOUT  **
 **  ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS  **
 **  FOR  A  PARTICULAR  PURPOSE.  See the full license text at the following link  **
 **  <http://www.quasarsoft.com/license.html>                                       **
 **                                                                                 **
 *************************************************************************************/

.set noreorder
.set noat
.text

#		 +------------------------+
#		 |  pBlk                  |
#		 |  BlockSize | Entries   |
#		 |  BitTable (1 integer)  | <-- This is variable 
#		 +------------------------+
#		 |  Entry number          | <--- pBlk points here
#		 |  InUse + pnt BitTable  |
#		 |  Memory                | <--- Pointer given back 
#		 |  Memory                |
#		 |  Memory                |
#		 |  Memory                |
#		 |  Memory                |
#		 +------------------------+
#		 |  Entry number          |
#		 |  InUse + pnt BitTable  |
#		 |  Memory                | <--- Pointer given back
#		 |  Memory                |
#		 |  Memory                |
#		 |  Memory                |
#		 |  Memory                |
#		 +------------------------+
#		 |  Entry number          |
#		 |  InUse + pnt BitTable  |
#		 |  Memory                | <--- Pointer given back 
#		 |  Memory                |
#		 |  Memory                |
#		 |  Memory                |
#		 |  Memory                |
#		 +------------------------+
#		 |  Entry number          |
#		 |  InUse + pnt BitTable  |
#		 |  Memory                | <--- Pointer given back
#		 |  Memory                |
#		 |  Memory                |
#		 |  Memory                |
#		 |  Memory                |
#		 +------------------------+


_FIX_pBlk = 0
_FIX_BlockSize = 10
_FIX_Entries = 12
_FIX_BitTable = 16		# Bit table 1=free 0=inuse

#
# This is allocating from interruptable pool
#	
# a0 = pointer to qqtFIX (Input) (NOT CHANGED)
# t7 = pointer (variable) in bit-table
# t6 = entry
# t5 = bit number free (0-31) later bitmask (bitnbr=8 bitmask = 0x0000.0010)
# t4 = fixed value 32 later used for address of memory block
# t3 = NOT-USED	
# t2 = NOT-USED
# t1 = Work register	
# t0 = Work register
# v0 = returned
	.global qFixAlloc
qFixAlloc: 
# the first part find a free position in the bit-table
50:	addiu	$t7, $a0, _FIX_BitTable
	add		$t6, $zero, $zero
	addi	$t4, $zero, 32
60:	lw		$t0, ($t7)
	clz		$t5, $t0
	add		$t6, $t6, $t5				# add to entry number
	bne		$t5, $t4, 70f				# if not 32 then found free spot
	lui		$t0, 0x8000					# we have $t7, $t6 and $t5 calcalated 
	b		60b
	addiu	$t7, $t7, 4					# next word
#
# Free bit found 
# t7, t6, t5 set. $t0 contains 0x8000.0000 set in delay slot
70:	
	srlv	$t5, $t0, $t5				# t5 = bit set for bit-table 
	lh		$t0, _FIX_Entries($a0)
	sltu 	$t0, $t6, $t0				# if t6<t0 then t0=1 else t0=0
										# if entry<max-entries then t0=1 else t0=0
	beq 	$t0, $zero, 90f
	nop
#
	nor     $t5, $t5, $zero             # not use as nand
71:	ll		$t0, ($t7)
	and		$t0, $t0, $t5				# clear the bit (inuse)
	sc		$t0, ($t7)					# and write back
	beq     $t0, $zero, 71b
#
	lh		$t0, _FIX_BlockSize($a0)
    addiu   $t0, $t0, 8                 # overhead of 2 integers
	mul		$t0, $t0, $t6				# t0 = size * entry
	lw		$t1, _FIX_pBlk($a0)
	addu	$t4, $t0, $t1				# t4 pnt to memory
#
73:	ll		$t1, 4($t4)					# save value in t1
	ori		$t0, $t1, 1					# set bit0 in t0
	sc		$t0, 4($t4)					# save back but now in use
	beq     $t0, $zero, 73b
#
	ext		$t0, $t1, 0, 1				# was the position in use? (get first bit)
	bne		$t0, $zero, 50b				# yes, so try again
	addiu	$t7, $t7, 1					# set lowest bit into the address
	sw		$t7, 4($t4)					# set the bit-address + inuse bit in memory
	nor     $t5, $t5, $zero             # not to compensate the previous not
	sw		$t5, 0($t4)					# set the bit-mask for the bit-table
	jr		$ra
	addiu	$v0, $t4, 8					# the address of the memory	 

# Exit if no space avalable	
90:	jr		$ra
	add		$v0, $zero, $zero
	

# a0 = pointer to memory 
# t1 = pointer in bit-table
# t2 = bit-mask
	.global qFixFree
qFixFree: 
11:	ll		$t1, -4($a0)				# bittable address + 1
    ins     $t1, $zero, 0, 1            # clear bit
    addiu   $t3, $t1, 0                 # t3 same as t1
	sc		$t3, -4($a0)				# write back t1 still contains bit-table address
	beq     $t3, $zero, 11b

	lw		$t2, -8($a0)				# get the bit mask
	
13:	ll		$t0, 0($t1)					# get bit-table
	or		$t0, $t0, $t2				# set the bit
	sc		$t0, 0($t1)					# write back in the bit-table
	beq     $t0, $zero, 13b
    nop

	jr		$ra
	nop
