/*************************************************************************************
 **  Q-KernelFree  Copyright (C) 2013 QuasarSoft Ltd.                               **
 **                                                                                 **
 **  This file is part of Q-KernelFree distribution.                                **
 **  Q-KernelFree is free software:  you can redistribute it and/or modify it under **
 **  the terms of the  GNU  General  Public  License  (version 3) as published  by  **
 **  the Free Software  Foundation ***** AND MODIFIED BY ***** the QuasarSoft Ltd.  **
 **  exception.                                                                     **
 **                                                                                 **
 **    *********************** The QuasarSoft Ltd. EXCEPTION ******************     **
 **    * You may not exercise any of the rights granted to You in any manner  *     **
 **    * that is primarily intended for or directed toward commercial         *     **
 **    * advantage or private monetary compensation. The exchange of the      *     **
 **    * Program for other copyrighted works by means of digital file-sharing *     **
 **    * or otherwise shall not be considered to be intended for or directed  *     **
 **    * toward commercial advantage or private monetary compensation,        *     **
 **    * provided there is no payment of any monetary compensation in         *     **
 **    * connection with the exchange of copyrighted works.                   *     **
 **    ************************************************************************     **
 **                                                                                 **
 **  Q-KernelFree is distributed in the hope that it will be useful,  but  WITHOUT  **
 **  ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS  **
 **  FOR  A  PARTICULAR  PURPOSE.  See the full license text at the following link  **
 **  <http://www.quasarsoft.com/license.html>                                       **
 **                                                                                 **
 *************************************************************************************/

#include <p32xxxx.h>
.set noreorder
.set noat
  
# Bit numbers in qvKernel
__InitDone = 0
__OsStarted = 1
__StatisticsOn = 2
__SwitchNotificationOn = 3
__USecOn = 4
__PriorityCheckOn = 5
__TimerInterruptOn = 6
__RtccInterruptOn = 7

# Bit numbers in qvSpawn
__FiberPrio4 = 0
__FiberPrio3 = 1
__FiberPrio2 = 2
__FiberPrio1 = 3
__FiberReserved4 = 4
__FiberTimerExpire = 5
__FiberReserved6 = 6
__FiberRtccExpire = 7
__FiberQueued = 8

.set noreorder
.set noat


__at = 52
__v0 = 56
__v1 = 60
__a0 = 64
__a1 = 68
__a2 = 72
__a3 = 76
__t0 = 80
__t1 = 84
__t2 = 88
__t3 = 92
__t4 = 96
__t5 = 100
__t6 = 104
__t7 = 108
__t8 = 112
__t9 = 116
__s0 = 120
__s1 = 124
__s2 = 128
__s3 = 132
__s4 = 136
__s5 = 140
__s6 = 144
__s7 = 148
__s8 = 152
__ra = 156
__HI = 160
__LO = 164
__SP = 168
__SR = 172
__EPC =176

__STAT = 1
__NOTIF = 1


.global yKernelInit
yKernelInit:
    addiu   t1, zero, 2                         # Clear the flag
    lui     t0, %hi(IFS0CLR)
    sw      t1, %lo(IFS0CLR)(t0)

    ori     t1, zero, 0xFF00                    # Clear bits involved
    lui     t0, %hi(IPC0CLR)
    sw      t1, %lo(IPC0CLR)(t0)

    addiu   t1, zero, 0x0400                    # Set the CS0IP priority (1)
    lui     t0, %hi(IPC0SET)
    sw      t1, %lo(IPC0SET)(t0)
    
    addiu   t1, zero, 2                         # Enable the interrupt
    lui     t0, %hi(IEC0SET)
    sw      t1, %lo(IEC0SET)(t0)

    jr      ra
    nop

    .global yGetMem_Last
yGetMem_Last:
    la      v0,_stack   
    jr      ra
    nop

    .global yGetMem_HeapSize
yGetMem_HeapSize:
    la      v0,_min_heap_size   
    jr      ra
    nop

    .global yGetMem_Heap
    .set noreorder
yGetMem_Heap:
    la      v0,_heap    
    jr      ra
    nop

.global yModeSleep
yModeSleep:
    la      t0, OSCCONSET
    addiu   t1, zero, 0x10
    lw      t1, 0(t0)
    wait
    nop
    nop
    nop
    jr      ra
    nop
    
    
.global yModeIdle
yModeIdle:
    la      t0, OSCCONCLR
    addiu   t1, zero, 0x10
    lw      t1, 0(t0)
    wait
    nop
    nop
    nop
    jr      ra
    nop
    

    .global yStart1
yStart1:
    addiu   t0, zero, -1
    sw      t0, %gp_rel(qvInCritical)(gp)           # we know that it must be 0 after startup
    lw      t0, %gp_rel(qvRdyList)(gp)
    sw      t0, %gp_rel(qvCurTcb)(gp)
    lw      $at, __at(t0)
    lw      v0, __v0(t0)
    lw      v1, __v1(t0)
    lw      a0, __a0(t0)
    lw      a1, __a1(t0)
    lw      a2, __a2(t0)
    lw      a3, __a3(t0)
    lw      t2, __t2(t0)
    lw      t3, __t3(t0)
    lw      t4, __t4(t0)
    lw      t5, __t5(t0)
    lw      t6, __t6(t0)
    lw      t7, __t7(t0)
    lw      t8, __t8(t0)
    lw      t9, __t9(t0)
    lw      s0, __s0(t0)
    lw      s1, __s1(t0)
    lw      s2, __s2(t0)
    lw      s3, __s3(t0)
    lw      s4, __s4(t0)
    lw      s5, __s5(t0)
    lw      s6, __s6(t0)
    lw      s7, __s7(t0)
    lw      s8, __s8(t0)
    lw      ra, __ra(t0)
    lw      sp, __SP(t0)
    lw      t1, __t1(t0)
    lw      t0, __t0(t0)
    di
    lw      k1, %gp_rel(qvCurTcb)(gp)
    lw      k0, __EPC(k1)
    mtc0    k0, $14
    lw      k0, __SR(k1)
    mtc0    k0, $12
    eret

    .global ySwitchThread
ySwitchThread:
1:  ll      t0, %gp_rel(qvInCritical)(gp)   # Lower InCritical (part 1 of EXIT_CRITICAL)
    addiu   t1, t0, 0
    addiu   t0, t0, -1
    sc      t0, %gp_rel(qvInCritical)(gp)
    beq     t0, zero, 1b
    nop
    bne     t1, zero, 99f                   # Return if still in critical section !(0)
#
# This function uses the kernel interrupt. This is required because the ll/sc
# sequences relies on an eret instruction to detect if the conditional store
# can be executed.
#
    addiu   t1, zero, 0x2                   # 
    lui     t0, %hi(IEC0SET)                # Enable Kernel interrupt (part 2 of EXIT_CRITICAL)
    sw      t1, %lo(IEC0SET)(t0)
    lui     t0, %hi(IFS0SET)                # Set the qKernel interrupt
    sw      t1, %lo(IFS0SET)(t0)
    nop                                     # Give the interrupt handler some
    nop                                     # time to start
    nop
    nop
    nop
    nop
    nop
    nop
    nop
    nop
    nop
    nop
    nop
99: jr      ra
    nop

/*********************************************************************
 * This is the actual interrupt handler that gets installed
 * in the interrupt vector table. It jumps to the core-timer
 * interrupt handler function.
 *
 ********************************************************************/
.section .vector_1, code
    j       qKernelIntHandler
    lw      k0, %gp_rel(qvInCritical)(gp)       # In critical section skip the scheduler

/*********************************************************************
 * qKernelIntHandler()
 * Interrupt handler function for the qKernel interrupt. The function
 * calls qqScheduler.
 ********************************************************************/
.text
qKernelIntHandler:
# Here we have loaded k0 with qvInCritical in the delay slot of the jump
#
    bgez    k0, InCriticalSoExit                # branch to get out of here (Still have to do the ei)
    addiu   k0, k0, 1   
    sw      k0, %gp_rel(qvInCritical)(gp)       # Store 1 in qvInCritical
    lw      k0, %gp_rel(qvCurTcb)(gp)           # 
    mfc0    k1, $14                             # Copy EPC in k1 --LOAD_DELAY--
    sw      $at, __at(k0)                       # save at
    sw      k1, __EPC(k0)                       # Save EPC in CurTcb
    mfc0    k1, $12                             # Get the STATUS --LOAD_DELAY--
    sw      s8, __s8(k0)                        # Save s8 in CurTcb
    sw      k1, __SR(k0)                        # Save STATUS in CurTcb
    addiu   k0, zero, 0b000001000000000         # Interrupt level = 1 EXL=0 ERL=0
    ins     k1, k0, 1, 15                       # Insert this in k1 and the status
    mtc0    k1, $12                             # Store in Status (IPL now RIPL) --LOAD_DELAY--
                                                # From here we can get interrupted. Can't use K registers
    lw      s8, %gp_rel(qvCurTcb)(gp)           # s8 = qvCurTcb
    sw      t0, __t0(s8)                        # t0 = temp register
#
    lui     t0, %hi(IFS0CLR)                    # clear the interrupt flag
    addiu   $at, zero, 2
    sw      $at, %lo(IFS0CLR)(t0)
#
    sw      sp, __SP(s8)                        # Save sp in CurTcb (delays slot always executed) 
    lw      sp, %gp_rel(qvIntStack)(gp)         # New stack Because we are in IntLevel 1 we can do this
    sw      a0, __a0(s8)
    sw      a1, __a1(s8)
    sw      a2, __a2(s8)
    sw      a3, __a3(s8)
    sw      v0, __v0(s8)
    sw      v1, __v1(s8)
    sw      t1, __t1(s8)
    sw      t2, __t2(s8)
    sw      t3, __t3(s8)
    sw      t4, __t4(s8)
    sw      t5, __t5(s8)
    sw      t6, __t6(s8)
    sw      t7, __t7(s8)
    sw      t8, __t8(s8)
    sw      t9, __t9(s8)
    sw      ra, __ra(s8)
    mfhi    t1                                  # HI register
    sw      t1, __HI(s8)                        # HI register
    mflo    t1                                  # LO register
    sw      t1, __LO(s8)                        # LO register

# Begin statistics  
#   lw      t2, %gp_rel(qvKernel)(gp)           # 
#   andi    t0, t2, (1<<__StatisticsOn)     # StatisticsOn
#   beq     t0, zero, 4f
#   mfc0    t0, $9                              # Copy counter from co-proc0 --LOAD_DELAY--
#   lw      t1, __StatCount(t7)             # Save counters in TCB
#   addu    t1, t0, t1
#   sw      t1, __StatCount(t7)             # Save counters in TCB
# End statistics    

# This is the entry-point for spawning functions
# The several functions always return here
TestSpawn:
    lw      t5, %gp_rel(qvSpawn)(gp)            # see if we need to spawn anything
    beq     t5, zero, TestContextSwitch         # no then continue with testing if we have to switch
#
    andi    t4, t5, 1<<__FiberPrio4
    bne     t4, zero, Prio4Fiber
#
    andi    t4, t5, 1<<__FiberPrio3
    bne     t4, zero, Prio3Fiber
#
    andi    t4, t5, 1<<__FiberPrio2
    bne     t4, zero, Prio2Fiber
#
    andi    t4, t5, 1<<__FiberPrio1
    bne     t4, zero, Prio1Fiber
#
    andi    t4, t5, 1<<__FiberReserved4         
    bne     t4, zero, Reserved4
#
    andi    t4, t5, 1<<__FiberTimerExpire
    bne     t4, zero, TimerExpireFiber
#
    andi    t4, t5, 1<<__FiberReserved6
    bne     t4, zero, Reserved6
#
    andi    t4, t5, 1<<__FiberRtccExpire
    bne     t4, zero, RtccExipereFiber
#
    nop
    beq     zero, zero, QueuedFiber
    nop

TestContextSwitch:
    lw      a1, %gp_rel(qvRdyList)(gp)          # a1 so we can use it later as second parameter     
#   beq     a1, s8, noContextSwitch             # if qvCurTcb==qvRdyList no context switch
# Begin NotifySwichOn
    lw      t0, %gp_rel(qvKernel)(gp)           # This qvKernel is only used for non-changing things
    andi    t0, t0, 1<<__SwitchNotificationOn   # SwitchNotification
    beq     t0, zero, 20f                       # skip if NotifySwitch off
    addiu   sp, sp, -16
    jal     qKrnNtfSwitch                       # a1=qvRdyList and a0=qvCurTcb in delay slot
    lw      a0, %gp_rel(qvCurTcb)(gp)   
    addiu   sp, sp, +16
20:
# End NotifySwichOn
    
#
# Here if the scheduler needs us to switch the thread. Save all the stuff that we want to save
# on the TCB of the thread that is active (** s8 is qvCurTcb **)
#
    sw      s0, __s0(s8)
    sw      s1, __s1(s8)
    sw      s2, __s2(s8)
    sw      s3, __s3(s8)
    sw      s4, __s4(s8)
    sw      s5, __s5(s8)
    sw      s6, __s6(s8)
    sw      s7, __s7(s8)

    lw      s8, %gp_rel(qvRdyList)(gp)      # we are making the new thread the current thread
    sw      s8, %gp_rel(qvCurTcb)(gp)           # qvCurTcb = qvRdyList

    lw      s7, __s7(s8)
    lw      s6, __s6(s8)
    lw      s5, __s5(s8)
    lw      s4, __s4(s8)
    lw      s3, __s3(s8)
    lw      s2, __s2(s8)
    lw      s1, __s1(s8)
    lw      s0, __s0(s8)
#
#   Here we got back when there is no context switch 
noContextSwitch:    
    lw      t0, __LO(s8)
    mtlo    t0
    lw      t0, __HI(s8)
    mthi    t0
    lw      ra, __ra(s8)
    lw      t9, __t9(s8)
    lw      t8, __t8(s8)
    lw      t7, __t7(s8)
    lw      t6, __t6(s8)
    lw      t5, __t5(s8)
    lw      t4, __t4(s8)
    lw      t3, __t3(s8)
    lw      t2, __t2(s8)
    lw      t1, __t1(s8)
    lw      v1, __v1(s8)
    lw      v0, __v0(s8)
    lw      a3, __a3(s8)
    lw      a2, __a2(s8)
    lw      a1, __a1(s8)
    lw      a0, __a0(s8)
    lw      $at, __at(s8)
    lw      sp, __SP(s8)
30: ll      t0, %gp_rel(qvInCritical)(gp)   # Lower InCritical (part 1 of EXIT_CRITICAL)
    addiu   t0, t0, -1
    sc      t0, %gp_rel(qvInCritical)(gp)
    beq     t0, zero, 30b
    nop
    lw      t0, __t0(s8)
    di
    ehb
    lw      k1, %gp_rel(qvCurTcb)(gp)           # qvCurTcb
    lw      s8, __s8(k1)
    lw      k0, __EPC(k1)
    mtc0    k0, $14
    lw      k0, __SR(k1)
    mtc0    k0, $12
    eret
    nop
    nop
    nop
    nop
    nop
    nop
    
#
# Here if the critical section was 0 or higher (-1) is not in critical section
# Because of the qENTER_CRITICAL() we are sure that an qEXIT_CRITICAL() will follow will activate us again. 
# Interrupts are still disabled
#
InCriticalSoExit:
    lui     k0, %hi(IEC0CLR)                    # Disable the kernel interrupt
    addiu   k1, zero, 2
    sw      k1, %lo(IEC0CLR)(k0)
    eret
    nop
    nop 
    nop
    nop
    nop 
    nop






Prio4Fiber:
1:  ll      t0, %gp_rel(qvSpawn)(gp)            # get qvSpwan
    ins     t0, zero, __FiberPrio4, 1           # clear bit
    sc      t0, %gp_rel(qvSpawn)(gp)            # and write back
    beq     t0, zero, 1b

    lw      t0, %gp_rel(qvSpawnFun + 12)(gp)
    jal     t0
    nop
    beq     zero, zero, TestSpawn
    nop

Prio3Fiber:
1:  ll      t0, %gp_rel(qvSpawn)(gp)            # get qvSpwan
    ins     t0, zero, __FiberPrio3, 1           # clear bit
    sc      t0, %gp_rel(qvSpawn)(gp)            # and write back
    beq     t0, zero, 1b

    lw      t0, %gp_rel(qvSpawnFun + 8)(gp)
    jal     t0
    nop
    beq     zero, zero, TestSpawn
    nop

Prio2Fiber:
1:  ll      t0, %gp_rel(qvSpawn)(gp)            # get qvSpwan
    ins     t0, zero, __FiberPrio2, 1           # clear bit
    sc      t0, %gp_rel(qvSpawn)(gp)            # and write back
    beq     t0, zero, 1b

    lw      t0, %gp_rel(qvSpawnFun + 4)(gp)
    jal     t0
    nop
    beq     zero, zero, TestSpawn
    nop

Prio1Fiber:
1:  ll      t0, %gp_rel(qvSpawn)(gp)            # get qvSpwan
    ins     t0, zero, __FiberPrio1, 1           # clear bit
    sc      t0, %gp_rel(qvSpawn)(gp)            # and write back
    beq     t0, zero, 1b

    lw      t0, %gp_rel(qvSpawnFun)(gp)
    jal     t0
    nop
    beq     zero, zero, TestSpawn
    nop

Reserved4:
1:  ll      t0, %gp_rel(qvSpawn)(gp)            # get qvSpwan
    ins     t0, zero, __FiberReserved4, 1       # clear bit
    sc      t0, %gp_rel(qvSpawn)(gp)            # and write back
    beq     t0, zero, 1b
    nop

    beq     zero, zero, TestSpawn
    nop

TimerExpireFiber:
1:  ll      t0, %gp_rel(qvSpawn)(gp)            # get qvSpwan
    ins     t0, zero, __FiberTimerExpire, 1     # clear bit
    sc      t0, %gp_rel(qvSpawn)(gp)            # and write back
    beq     t0, zero, 1b
    nop

    jal     xFbrTimerExpire
    nop
    beq     zero, zero, TestSpawn
    nop

Reserved6:
1:  ll      t0, %gp_rel(qvSpawn)(gp)            # get qvSpwan
    ins     t0, zero, __FiberReserved6, 1       # clear bit
    sc      t0, %gp_rel(qvSpawn)(gp)            # and write back
    beq     t0, zero, 1b
    nop

    beq     zero, zero, TestSpawn
    nop

RtccExipereFiber:
1:  ll      t0, %gp_rel(qvSpawn)(gp)            # get qvSpwan
    ins     t0, zero, __FiberRtccExpire, 1      # clear bit
    sc      t0, %gp_rel(qvSpawn)(gp)            # and write back
    beq     t0, zero, 1b

    lw      t0, %gp_rel(qvSpawnRtccExpire)(gp)
    jal     t0
    nop
    beq     zero, zero, TestSpawn
    nop

QueuedFiber:
1:  ll      t0, %gp_rel(qvSpawn)(gp)            # get qvSpwan
    ins     t0, zero, __FiberQueued, 1          # clear bit 
    sc      t0, %gp_rel(qvSpawn)(gp)            # and write back
    beq     t0, zero, 1b
#
2:  lw      t0, %gp_rel(qvFbrGet)(gp)           # Get the entry where to read
    lw      t1, 4(t0)                           # Address of function
    andi    t2, t1, 1                           # Is it in use? ($t2!=0)
    beq     t2, zero, TestSpawn                 # No than we are done
    lw      a0, 8(t0)                           # param 1
    lw      a1, 12(t0)                          # param 2
    sw      zero, 4(t0)                         # free-up position
    ins     t1, zero, 0, 1                      # clear bit 0 in address function
    beq     t1, zero, TestSpawn                 # If address of function 0 then it was in the process of writing 
    lw      t0, 0(t0)                           # next entry in linked list
    sw      t0, %gp_rel(qvFbrGet)(gp)           # write the next entry in qvFbrGet
    jal     t1
    addiu   sp, sp, -16 
    beq     zero, zero, 2b
    nop                                         # Address of function




#   void qBytMov(INT8U *pFrom, INT8U *pTo, INTU Size);
    .global qBytMov ########################
qBytMov:
    beq     a2, zero, 20f
10: addiu   a2, a2, -1
    lbu     t0, 0(a0)
    sb      t0, 0(a1)
    beq     a2, zero, 20f
    addiu   a2, a2, -1
    lbu     t0, 1(a0)
    sb      t0, 1(a1)
    beq     a2, zero, 20f
    addiu   a2, a2, -1
    lbu     t0, 2(a0)
    sb      t0, 2(a1)
    beq     a2, zero, 20f
    addiu   a2, a2, -1
    lbu     t0, 3(a0)
    sb      t0, 3(a1)
    beq     a2, zero, 20f
    addiu   a2, a2, -1
    lbu     t0, 4(a0)
    sb      t0, 4(a1)
    beq     a2, zero, 20f
    addiu   a2, a2, -1
    lbu     t0, 5(a0)
    sb      t0, 5(a1)
    beq     a2, zero, 20f
    addiu   a2, a2, -1
    lbu     t0, 6(a0)
    sb      t0, 6(a1)
    beq     a2, zero, 20f
    addiu   a2, a2, -1
    lbu     t0, 7(a0)
    sb      t0, 7(a1)
    addiu   a0, a0, 8       
    bne     a2, zero, 10b
    addiu   a1, a1, 8       
#
20: jr      ra
    nop
    
    
#   void qWrdMov(INTU *pFrom, INTU *pTo, INTU Size);
    .global qWrdMov ########################
qWrdMov:
    beq     a2, zero, 20f
10: addiu   a2, a2, -4
    lw      t0, 0(a0)
    sw      t0, 0(a1)
    beq     a2, zero, 20f
    addiu   a2, a2, -4
    lw      t0, 4(a0)
    sw      t0, 4(a1)
    beq     a2, zero, 20f
    addiu   a2, a2, -4
    lw      t0, 8(a0)
    sw      t0, 8(a1)
    beq     a2, zero, 20f
    addiu   a2, a2, -4
    lw      t0, 12(a0)
    sw      t0, 12(a1)
    beq     a2, zero, 20f
    addiu   a2, a2, -4
    lw      t0, 16(a0)
    sw      t0, 16(a1)
    beq     a2, zero, 20f
    addiu   a2, a2, -4
    lw      t0, 20(a0)
    sw      t0, 20(a1)
    beq     a2, zero, 20f
    addiu   a2, a2, -4
    lw      t0, 24(a0)
    sw      t0, 24(a1)
    beq     a2, zero, 20f
    addiu   a2, a2, -4
    lw      t0, 28(a0)
    sw      t0, 28(a1)
    addiu   a0, a0, 32
    bne     a2, zero, 10b
    addiu   a1, a1, 32
#
20: jr      ra
    nop


#   void qWrdClr(INTU *p, INTU Size);
    .global qWrdClr ########################
qWrdClr:
    beq     a1, zero, 20f
10: addiu   a1, a1, -4
    sw      zero, 0(a0)
    beq     a1, zero, 20f
    addiu   a1, a1, -4
    sw      zero, 4(a0)
    beq     a1, zero, 20f
    addiu   a1, a1, -4
    sw      zero, 8(a0)
    beq     a1, zero, 20f
    addiu   a1, a1, -4
    sw      zero, 12(a0)
    beq     a1, zero, 20f
    addiu   a1, a1, -4
    sw      zero, 16(a0)
    beq     a1, zero, 20f
    addiu   a1, a1, -4
    sw      zero, 20(a0)
    beq     a1, zero, 20f
    addiu   a1, a1, -4
    sw      zero, 24(a0)
    beq     a1, zero, 20f
    addiu   a1, a1, -4
    sw      zero, 28(a0)
    bne     a1, zero, 10b
    addiu   a0, a0, 32      
#
20: jr      ra
    nop


#   void qBytSet(INTU *p, INTU Size);
    .global qBytSet ########################
qBytSet:
    addiu   t0, zero, -1
    beq     a1, zero, 20f
10: addiu   a1, a1, -1
    sb      t0, 0(a0)
    beq     a1, zero, 20f
    addiu   a1, a1, -1
    sb      t0, 1(a0)
    beq     a1, zero, 20f
    addiu   a1, a1, -1
    sb      t0, 2(a0)
    beq     a1, zero, 20f
    addiu   a1, a1, -1
    sb      t0, 3(a0)
    beq     a1, zero, 20f
    addiu   a1, a1, -1
    sb      t0, 4(a0)
    beq     a1, zero, 20f
    addiu   a1, a1, -1
    sb      t0, 5(a0)
    beq     a1, zero, 20f
    addiu   a1, a1, -1
    sb      t0, 6(a0)
    beq     a1, zero, 20f
    addiu   a1, a1, -1
    sb      t0, 7(a0)
    bne     a1, zero, 10b
    addiu   a0, a0, 8       
#
20: jr      ra
    nop

#   void qWrdSet(INTU *p, INTU Size);
    .global qWrdSet ########################
qWrdSet:
    addiu   t0, zero, -1
    beq     a1, zero, 20f
10: addiu   a1, a1, -4
    sw      t0, 0(a0)
    beq     a1, zero, 20f
    addiu   a1, a1, -4
    sw      t0, 4(a0)
    beq     a1, zero, 20f
    addiu   a1, a1, -4
    sw      t0, 8(a0)
    beq     a1, zero, 20f
    addiu   a1, a1, -4
    sw      t0, 12(a0)
    beq     a1, zero, 20f
    addiu   a1, a1, -4
    sw      t0, 16(a0)
    beq     a1, zero, 20f
    addiu   a1, a1, -4
    sw      t0, 20(a0)
    beq     a1, zero, 20f
    addiu   a1, a1, -4
    sw      t0, 24(a0)
    beq     a1, zero, 20f
    addiu   a1, a1, -4
    sw      t0, 28(a0)
    bne     a1, zero, 10b
    addiu   a0, a0, 32      
#
20: jr      ra
    nop



    .global qBytIncAtomic
qBytIncAtomic:
    beq     zero, zero, qBytIncDecAtomic
    addiu   t7, zero, 1

   .global qBytDecAtomic
qBytDecAtomic:
    addiu   t7, zero, -1

qBytIncDecAtomic:
    addiu   t0, a0, 0
    andi    t1, t0, 3
    ins     t0, zero, 0, 2
    beq     t1, zero, 1f
    addiu   t1, t1, -1
    beq     t1, zero, 11f
    addiu   t1, t1, -1
    beq     t1, zero, 21f
    nop
31: ll      t1, 0(t0)
    ext     t2, t1, 24, 8
    addu    t2, t2, t7
    ins     t1, t2, 24, 8
    sc      t1, 0(t0)
    beq     t1, zero, 31b
    nop
    jr      ra
    nop

21: ll      t1, 0(t0)
    ext     t2, t1, 16, 8
    addu    t2, t2, t7
    ins     t1, t2, 16, 8
    sc      t1, 0(t0)
    beq     t1, zero, 21b
    nop
    jr      ra
    nop

11: ll      t1, 0(t0)
    ext     t2, t1, 8, 8
    addu    t2, t2, t7
    ins     t1, t2, 8, 8
    sc      t1, 0(t0)
    beq     t1, zero, 11b
    nop
    jr      ra
    nop

1:  ll      t1, 0(t0)
    ext     t2, t1, 0, 8
    addu    t2, t2, t7
    ins     t1, t2, 0, 8
    sc      t1, 0(t0)
    beq     t1, zero, 1b
    nop
    jr      ra
    nop

