/*************************************************************************************
 **  Q-KernelFree  Copyright (C) 2013 QuasarSoft Ltd.                               **
 **                                                                                 **
 **  This file is part of Q-KernelFree distribution.                                **
 **  Q-KernelFree is free software:  you can redistribute it and/or modify it under **
 **  the terms of the  GNU  General  Public  License  (version 3) as published  by  **
 **  the Free Software  Foundation ***** AND MODIFIED BY ***** the QuasarSoft Ltd.  **
 **  exception.                                                                     **
 **                                                                                 **
 **    *********************** The QuasarSoft Ltd. EXCEPTION ******************     **
 **    * You may not exercise any of the rights granted to You in any manner  *     **
 **    * that is primarily intended for or directed toward commercial         *     **
 **    * advantage or private monetary compensation. The exchange of the      *     **
 **    * Program for other copyrighted works by means of digital file-sharing *     **
 **    * or otherwise shall not be considered to be intended for or directed  *     **
 **    * toward commercial advantage or private monetary compensation,        *     **
 **    * provided there is no payment of any monetary compensation in         *     **
 **    * connection with the exchange of copyrighted works.                   *     **
 **    ************************************************************************     **
 **                                                                                 **
 **  Q-KernelFree is distributed in the hope that it will be useful,  but  WITHOUT  **
 **  ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS  ** 
 **  FOR  A  PARTICULAR  PURPOSE.  See the full license text at the following link  ** 
 **  <http://www.quasarsoft.com/license.html>                                       ** 
 **                                                                                 **
 *************************************************************************************/  

#include "qKernel.h"
 

pMSG qMsgReceive(pQUE pQue) {
    pMSG msg = 0;
    
#ifndef __NO_CHECK__
    if (xTestWait(pQue, xTYPE_QUE, qERR_QUE_ID, 1000)) // 1000 so it test waiting conditions

        return NULL;
#endif

    qCrtEnter();
    if (pQue->Entries) {                        // Is there something in the queue
        pQue->Entries--;
        msg = *pQue->pOut++;                    // Get the message
        if (pQue->pOut==pQue->pMax)
            pQue->pOut = &pQue->pMessages;
    }
    else {
        xThrSuspendOnObject((pOBJ)pQue);        // Switch Thread and EXIT_CRITICAL
        qCrtEnter();
        if (pQue->Entries) {
            pQue->Entries--;
            msg = *pQue->pOut++;                // Get the message
            if (pQue->pOut==pQue->pMax)
                pQue->pOut = &pQue->pMessages;
        }
        else {
            qCrtExit();
            return NULL;                        // if there is nothing then we are done
        }
    }
    // ready waiting senders
    xQueReadyWaiting(pQue);
    return msg;
}



