/*************************************************************************************
 **  Q-KernelFree  Copyright (C) 2013 QuasarSoft Ltd.                               **
 **                                                                                 **
 **  This file is part of Q-KernelFree distribution.                                **
 **  Q-KernelFree is free software:  you can redistribute it and/or modify it under **
 **  the terms of the  GNU  General  Public  License  (version 3) as published  by  **
 **  the Free Software  Foundation ***** AND MODIFIED BY ***** the QuasarSoft Ltd.  **
 **  exception.                                                                     **
 **                                                                                 **
 **    *********************** The QuasarSoft Ltd. EXCEPTION ******************     **
 **    * You may not exercise any of the rights granted to You in any manner  *     **
 **    * that is primarily intended for or directed toward commercial         *     **
 **    * advantage or private monetary compensation. The exchange of the      *     **
 **    * Program for other copyrighted works by means of digital file-sharing *     **
 **    * or otherwise shall not be considered to be intended for or directed  *     **
 **    * toward commercial advantage or private monetary compensation,        *     **
 **    * provided there is no payment of any monetary compensation in         *     **
 **    * connection with the exchange of copyrighted works.                   *     **
 **    ************************************************************************     **
 **                                                                                 **
 **  Q-KernelFree is distributed in the hope that it will be useful,  but  WITHOUT  **
 **  ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS  ** 
 **  FOR  A  PARTICULAR  PURPOSE.  See the full license text at the following link  ** 
 **  <http://www.quasarsoft.com/license.html>                                       ** 
 **                                                                                 **
 *************************************************************************************/  

#include "qKernel.h"


bool qMtxLockNB(pMTX pMtx) {

#ifndef __NO_CHECK__
    if (qKrnInIsr()) {
        xErrNtf(qERR_MTX_ISR);
        return false;
    }
    if (pMtx==NULL || pMtx->Type!= xTYPE_MTX) {
        xErrNtf(qERR_MTX_ID);
        return false;
    }
    if (qKrnInFiber()) {
        xErrNtf(qERR_MTX_FBR);
        return false;
    }
    if (!xKrnIsOsStarted()) {
        xErrNtf(qERR_MTX_NO_START);
        return false;
    }
#endif
    
    qCrtEnter();
    if (pMtx->Owner==0 || pMtx->Owner==qvCurTcb) { // Is the mutex available or we own it then lock it
        pMtx->Owner = qvCurTcb;                 // We are the owner so store us
        pMtx->OrgPrio = qvCurTcb->Prio;         // and the original priority
        qCrtExit();
        return true;
    }
    qCrtExit();
    return false;
}

