/*************************************************************************************
 **  Q-KernelFree  Copyright (C) 2013 QuasarSoft Ltd.                               **
 **                                                                                 **
 **  This file is part of Q-KernelFree distribution.                                **
 **  Q-KernelFree is free software:  you can redistribute it and/or modify it under **
 **  the terms of the  GNU  General  Public  License  (version 3) as published  by  **
 **  the Free Software  Foundation ***** AND MODIFIED BY ***** the QuasarSoft Ltd.  **
 **  exception.                                                                     **
 **                                                                                 **
 **    *********************** The QuasarSoft Ltd. EXCEPTION ******************     **
 **    * You may not exercise any of the rights granted to You in any manner  *     **
 **    * that is primarily intended for or directed toward commercial         *     **
 **    * advantage or private monetary compensation. The exchange of the      *     **
 **    * Program for other copyrighted works by means of digital file-sharing *     **
 **    * or otherwise shall not be considered to be intended for or directed  *     **
 **    * toward commercial advantage or private monetary compensation,        *     **
 **    * provided there is no payment of any monetary compensation in         *     **
 **    * connection with the exchange of copyrighted works.                   *     **
 **    ************************************************************************     **
 **                                                                                 **
 **  Q-KernelFree is distributed in the hope that it will be useful,  but  WITHOUT  **
 **  ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS  ** 
 **  FOR  A  PARTICULAR  PURPOSE.  See the full license text at the following link  ** 
 **  <http://www.quasarsoft.com/license.html>                                       ** 
 **                                                                                 **
 *************************************************************************************/  

#include "qKernel.h"

/*
    This function sets the current time
*/

void qRtcSetDatTim(uint32_t new) {
    uint32_t old;
    
#ifndef __NO_CHECK__
    if (qKrnInIsr()) {
        xErrNtf(qERR_RTC_ISR);
        return;
    }    
    if (!xKrnIsOsStarted()) {
        xErrNtf(qERR_RTC_NO_START);
        return;
    }    
    if (qKrnInFiber()) {
        xErrNtf(qERR_RTC_FBR);
        return;
    }    
    if (qKrnInCritical()) {
        xErrNtf(qERR_RTC_CRITICAL);
        return;
    }
	if (qvRtcc==0) {
		xErrNtf(qERR_RTC_NO_RTCC);
		return;
	}
#endif

    qCrtEnter();
    old = yRtccGetDatTim();
    yRtccSetDatTim(new);                        // set new time 
    if (new < old) {                            // if new is back in time. It could be that things did time-out
        qFbrSpawnRtcc();                        // activate xFbrRTCCExpire
    }        
    qCrtExit();
}    

