/*************************************************************************************
 **  Q-KernelFree  Copyright (C) 2013 QuasarSoft Ltd.                               **
 **                                                                                 **
 **  This file is part of Q-KernelFree distribution.                                **
 **  Q-KernelFree is free software:  you can redistribute it and/or modify it under **
 **  the terms of the  GNU  General  Public  License  (version 3) as published  by  **
 **  the Free Software  Foundation ***** AND MODIFIED BY ***** the QuasarSoft Ltd.  **
 **  exception.                                                                     **
 **                                                                                 **
 **    *********************** The QuasarSoft Ltd. EXCEPTION ******************     **
 **    * You may not exercise any of the rights granted to You in any manner  *     **
 **    * that is primarily intended for or directed toward commercial         *     **
 **    * advantage or private monetary compensation. The exchange of the      *     **
 **    * Program for other copyrighted works by means of digital file-sharing *     **
 **    * or otherwise shall not be considered to be intended for or directed  *     **
 **    * toward commercial advantage or private monetary compensation,        *     **
 **    * provided there is no payment of any monetary compensation in         *     **
 **    * connection with the exchange of copyrighted works.                   *     **
 **    ************************************************************************     **
 **                                                                                 **
 **  Q-KernelFree is distributed in the hope that it will be useful,  but  WITHOUT  **
 **  ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS  ** 
 **  FOR  A  PARTICULAR  PURPOSE.  See the full license text at the following link  ** 
 **  <http://www.quasarsoft.com/license.html>                                       ** 
 **                                                                                 **
 *************************************************************************************/  

#include "qKernel.h"


unsigned qThrEvtWaitNB(unsigned EventFlags, WAIT_TYPE WaitType) {
    unsigned events;
    uint8_t ready;
    
#ifndef __NO_CHECK__
    if (xTestWait(0, xTYPE_TCB, qERR_THR_ID, 0))
        return 0;
    if (!EventFlags) {
        xErrNtf(qERR_THR_NO_FLAGS);
        return 0;
    }
    if (WaitType < WAIT_TYPE_ALL || WaitType > WAIT_TYPE_ANY_AND_CLEAR) {
        xErrNtf(qERR_THR_WAIT_TYPE);
        return 0;
    }
#endif
    ready = 0;

    qCrtEnter();
    events = qvCurTcb->CurThrEvents&EventFlags; // Compare the results and save
    if (WaitType&1) {                           // OR case in Bit 0
        if (events) ready=1;
    }
    else {                                      // AND case
        if (events==EventFlags) ready=1;
    }
    if (ready) {
        if (WaitType&2) {                       // Clear in Bit 1
            qvCurTcb->CurThrEvents &= ~events;  // clear the events that were set
        }
    }
    else {
        events = 0;
    }
    qCrtExit();
    return events;
}

