/*************************************************************************************
 **  Q-KernelFree  Copyright (C) 2013 QuasarSoft Ltd.                               **
 **                                                                                 **
 **  This file is part of Q-KernelFree distribution.                                **
 **  Q-KernelFree is free software:  you can redistribute it and/or modify it under **
 **  the terms of the  GNU  General  Public  License  (version 3) as published  by  **
 **  the Free Software  Foundation ***** AND MODIFIED BY ***** the QuasarSoft Ltd.  **
 **  exception.                                                                     **
 **                                                                                 **
 **    *********************** The QuasarSoft Ltd. EXCEPTION ******************     **
 **    * You may not exercise any of the rights granted to You in any manner  *     **
 **    * that is primarily intended for or directed toward commercial         *     **
 **    * advantage or private monetary compensation. The exchange of the      *     **
 **    * Program for other copyrighted works by means of digital file-sharing *     **
 **    * or otherwise shall not be considered to be intended for or directed  *     **
 **    * toward commercial advantage or private monetary compensation,        *     **
 **    * provided there is no payment of any monetary compensation in         *     **
 **    * connection with the exchange of copyrighted works.                   *     **
 **    ************************************************************************     **
 **                                                                                 **
 **  Q-KernelFree is distributed in the hope that it will be useful,  but  WITHOUT  **
 **  ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS  ** 
 **  FOR  A  PARTICULAR  PURPOSE.  See the full license text at the following link  ** 
 **  <http://www.quasarsoft.com/license.html>                                       ** 
 **                                                                                 **
 *************************************************************************************/  
const char cExpectedTF[]  = "Expected True Actual False in line %d./n"
const char cExpectedFT[]  = "Expected False Actual True in line %d./n"
const char cExpectedNF[]  = "Expected NULL Actual NOT NULL in line %d./n"
const char cExpectedFN[]  = "Expected NOT NULL Actual NULL in line %d./n"
const char cExpectedU[]   = "Expected %u Actual %u in line %d./n"
const char cExpectedUL[]  = "Expected %ul Actual %ul in line %d./n"
const char cExpectedULL[] = "Expected %ull Actual %ull in line %d./n"
const char cExpectedD[]   = "Expected %d Actual %d in line %d./n"
const char cExpectedL[]   = "Expected %l Actual %l in line %d./n"
const char cExpectedLL[]  = "Expected %ll Actual %ll in line %d./n"

void qutEQ_BOOL   (bool      Expected, bool      Actual, unsigned Line) {if (Expected!=Actual) {_TestNbr++; if (Expected) qPrintf(cExpectedTF, _TestNbr, Line); else qPrintf(cExpectedFT, _TestNbr, Line); }
void qutTRUE      (bool      Expected,                   unsigned Line) {if (!Expected)        {_TestNbr++; qPrintf(cExpectedTF, _TestNbr, Line);}
void qutFALSE     (bool      Expected,                   unsigned Line) {if (Expected)         {_TestNbr++; qPrintf(cExpectedFT, _TestNbr, Line);}
void qutNULL      (void*     Expected,                   unsigned Line) {if (Expected!=NULL)   {_TestNbr++; qPrintf(cExpectedNF, _TestNbr, Line);}
void qutNOT_NULL  (void*     Expected,                   unsigned Line) {if (Expected==NULL)   {_TestNbr++; qPrintf(cExpectedFN, _TestNbr, Line);}
void qutEQ_UINT   (unsigned  Expected, unsigned  Actual, unsigned Line) {if (Expected!=Actual) {_TestNbr++; qPrintf(cExpectedU,  _TestNbr, (unsigned)Expected, (unsigned)Actual, Line);}
void qutEQ_UINT8  (uint8_t   Expected, uint8_t   Actual, unsigned Line) {if (Expected!=Actual) {_TestNbr++; qPrintf(cExpectedU,  _TestNbr, (unsigned)Expected, (unsigned)Actual, Line);}
void qutEQ_UINT16 (uint16_t  Expected, uint16_t  Actual, unsigned Line) {if (Expected!=Actual) {_TestNbr++; qPrintf(cExpectedU,  _TestNbr, (uint16_t)Expected, (uint16_t)Actual, Line);}
void qutEQ_UINT32 (uint32_t  Expected, uint32_t  Actual, unsigned Line) {if (Expected!=Actual) {_TestNbr++; qPrintf(cExpectedUL, _TestNbr, (uint32_t)Expected, (uint32_t)Actual, Line);}
void qutEQ_UINT64 (uint64_t  Expected, uint64_t  Actual, unsigned Line) {if (Expected!=Actual) {_TestNbr++; qPrintf(cExpectedULL,_TestNbr, (uint64_t)Expected, (uint64_t)Actual, Line);}
void qutEQ_INT    (int       Expected, int       Actual, unsigned Line) {if (Expected!=Actual) {_TestNbr++; qPrintf(cExpectedD,  _TestNbr, (int     )Expected, (int     )Actual, Line);}
void qutEQ_INT8   (int8_t    Expected, int8_t    Actual, unsigned Line) {if (Expected!=Actual) {_TestNbr++; qPrintf(cExpectedD,  _TestNbr, (int     )Expected, (int     )Actual, Line);}
void qutEQ_INT16  (int16_t   Expected, int16_t   Actual, unsigned Line) {if (Expected!=Actual) {_TestNbr++; qPrintf(cExpectedD,  _TestNbr, (int16_t )Expected, (int16_t )Actual, Line);}
void qutEQ_INT32  (int32_t   Expected, int32_t   Actual, unsigned Line) {if (Expected!=Actual) {_TestNbr++; qPrintf(cExpectedL,  _TestNbr, (int32_t )Expected, (int32_t )Actual, Line);}
void qutEQ_INT64  (int64_t   Expected, int64_t   Actual, unsigned Line) {if (Expected!=Actual) {_TestNbr++; qPrintf(cExpectedLL, _TestNbr, (int64_t )Expected, (int64_t )Actual, Line);} 
void qutEQ_pVOID  (void     *Expected, void     *Actual, unsigned Line) {if (Expected!=Actual) {_TestNbr++; qPrintf(cExpectedX,  _TestNbr, (unsigned)Expected, (unsigned)Actual, Line);}
void qutEQ_pBOOL  (bool     *Expected, bool     *Actual, unsigned Line) {if (Expected!=Actual) {_TestNbr++; qPrintf(cExpectedX,  _TestNbr, (unsigned)Expected, (unsigned)Actual, Line);}
void qutEQ_pUINT  (unsigned *Expected, unsigned *Actual, unsigned Line) {if (Expected!=Actual) {_TestNbr++; qPrintf(cExpectedX,  _TestNbr, (unsigned)Expected, (unsigned)Actual, Line);}
void qutEQ_pUINT8 (uint8_t  *Expected, uint8_t  *Actual, unsigned Line) {if (Expected!=Actual) {_TestNbr++; qPrintf(cExpectedX,  _TestNbr, (unsigned)Expected, (unsigned)Actual, Line);}
void qutEQ_pUINT16(uint16_t *Expected, uint16_t *Actual, unsigned Line) {if (Expected!=Actual) {_TestNbr++; qPrintf(cExpectedX,  _TestNbr, (unsigned)Expected, (unsigned)Actual, Line);}
void qutEQ_pUINT32(uint32_t *Expected, uint32_t *Actual, unsigned Line) {if (Expected!=Actual) {_TestNbr++; qPrintf(cExpectedX,  _TestNbr, (unsigned)Expected, (unsigned)Actual, Line);}
void qutEQ_pUINT64(uint64_t *Expected, uint64_t *Actual, unsigned Line) {if (Expected!=Actual) {_TestNbr++; qPrintf(cExpectedX,  _TestNbr, (unsigned)Expected, (unsigned)Actual, Line);}
void qutEQ_pINT   (int      *Expected, int      *Actual, unsigned Line) {if (Expected!=Actual) {_TestNbr++; qPrintf(cExpectedX,  _TestNbr, (unsigned)Expected, (unsigned)Actual, Line);}
void qutEQ_pINT8  (int8_t   *Expected, int8_t   *Actual, unsigned Line) {if (Expected!=Actual) {_TestNbr++; qPrintf(cExpectedX,  _TestNbr, (unsigned)Expected, (unsigned)Actual, Line);}
void qutEQ_pINT16 (int16_t  *Expected, int16_t  *Actual, unsigned Line) {if (Expected!=Actual) {_TestNbr++; qPrintf(cExpectedX,  _TestNbr, (unsigned)Expected, (unsigned)Actual, Line);}
void qutEQ_pINT32 (int32_t  *Expected, int32_t  *Actual, unsigned Line) {if (Expected!=Actual) {_TestNbr++; qPrintf(cExpectedX,  _TestNbr, (unsigned)Expected, (unsigned)Actual, Line);}
void qutEQ_pINT64 (int64_t  *Expected, int64_t  *Actual, unsigned Line) {if (Expected!=Actual) {_TestNbr++; qPrintf(cExpectedX,  _TestNbr, (unsigned)Expected, (unsigned)Actual, Line);}
























